#ifndef _BILLIARDZ_H_
#define _BILLIARDZ_H_

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <string.h>

#define WIDTH  240
#define HEIGHT 320

#define F_WIDTH  Fixed(WIDTH)
#define F_HEIGHT Fixed(HEIGHT)

#ifdef LOCAL_IMAGES
# define DATA_PREFIX "./"
#else
# define DATA_PREFIX "/opt/QtPalmtop/share/billiardz/"
#endif

/* Table colors */
#define TABLE_GREEN_R  41
#define TABLE_GREEN_G 109
#define TABLE_GREEN_B  41

#define TABLE_RED_R   140
#define TABLE_RED_G     8
#define TABLE_RED_B     8

/* Number of pool balls. */
#define NUM_BALLS 16

/* Utility functions */
#ifndef MAX
# define MAX(a,b) ((a) > (b) ? (a) : (b))
#endif

#ifndef MIN
# define MIN(a,b) ((a) < (b) ? (a) : (b))
#endif

#include "Fixed.h"
#include "SDL_gfxPrimitives.h"

#include "MouseListener.h"
#include "Vec2D.h"
#include "Physics.h"
#include "ImageLoader.h"
#include "Sprite.h"
#include "SplashScreen.h"
#include "Ball.h"
#include "Player.h"
#include "CueStick.h"
#include "CueStickListener.h"
#include "Side.h"
#include "Hole.h"
#include "PlayerDisplay.h"
#include "PoolTable.h"
#include "PoolRoom.h"
#include "PoolGame.h"
#include "PowerMeter.h"

#include "Rules.h"
#include "EightBallRules.h"

#endif /* _BILLIARDZ_H_ */
