#ifndef _CUESTICK_H_
#define _CUESTICK_H_

#include "BilliardZ.h"

class Ball;
class CueStickListener;
class MouseListener;
class PoolGame;
class Sprite;

class CueStick : public MouseListener
{
	public:
		CueStick(SDL_Surface *screen, PoolGame *game);
		~CueStick();

		const char *getName() const;

		void setVisible(bool visible = true);
		void setHidden(bool hidden = true) { setVisible(!hidden); }
		bool isVisible() const;

		void setTargetBall(Ball *ball);
		Ball *getTargetBall() const;

		void rotateLeft(Fixed degrees);
		void rotateRight(Fixed degrees);

		void setAngle(Fixed angle);
		void setAngleRad(Fixed angle);
		Fixed getAngleRad() const;
		Fixed getAngleDeg() const;

		void setDistance(Fixed distance);
		Fixed getDistance() const;

		bool hitBall(Fixed level, Fixed maxLevel);

		void registerListener(CueStickListener *listener);

		void render(bool update = true);

		bool mousePressed(unsigned int x, unsigned int y);
		bool mouseReleased(unsigned int x, unsigned int y);
		bool mouseDragged(unsigned int x, unsigned int y);

	private:
		Fixed stickLength;
		Fixed tipLength;

		SDL_Surface *screen;
		SDL_Surface *surface;
		PoolGame *game;
		Fixed distance;
		Fixed angle;
		bool visible;

		Sint16 x[3], y[3];
		Sint16 oldX[3], oldY[3];

		Ball *targetBall;

		CueStickListener *listener;
};

#endif /* _CUESTICK_H_ */
