#include "Hole.h"

Hole::Hole(SDL_Surface *screen, HoleSide side)
	: Sprite(screen, IMAGE_HOLE, true), side(side)
{
}

Hole::~Hole()
{
}

const char *
Hole::getName() const
{
	return "Hole";
}

HoleSide
Hole::getSide() const
{
	return side;
}

bool
Hole::collidesWith(Sprite *sprite)
{
	Ball *ball;
	Fixed dx, dy;
	Fixed distance;
	Fixed radius;

	if (this == sprite)
		return false;

	if (strcmp(sprite->getName(), "Ball"))
		return false;

	ball = (Ball *)sprite;

	radius = getImage()->w / 2;

	dx = (getX() + radius) - ball->getCenterX();
	dy = (getY() + radius) - ball->getCenterY();

	distance = dx.hypot(dy);

	if (distance <= radius * 2)
	{
		return true;
	}

	return false;
}

