#include "Player.h"

#define PLAYERLIST_OFFSET_X (WIDTH - 30)
#define PLAYERLIST_OFFSET_Y 10

extern ImageLoader *imageLoader;

Player::Player(int num)
	: number(num), numBallsIn(0), ballType(BALLTYPE_UNSET)
{
	nextBallPic = imageLoader->load(IMAGE_UNSET_BALL, true);
}

Player::~Player()
{
}

void
Player::reset()
{
	numBallsIn = 0;
	ballType = BALLTYPE_UNSET;
}

void
Player::setNumber(int num)
{
	this->number = num;
}

int
Player::getNumber() const
{
	return number;
}

void
Player::setBallType(BallType type)
{
	this->ballType = type;
}

BallType
Player::getBallType() const
{
	return ballType;
}

void
Player::incNumBallsIn()
{
	numBallsIn++;
}

int
Player::getNumBallsIn() const
{
	return numBallsIn;
}

SDL_Surface *
Player::getNextBallPic() const
{
	return nextBallPic;
}

void
Player::setNextBallPic(SDL_Surface *image)
{
	nextBallPic = image;
}

