#ifndef _POOLGAME_H_
#define _POOLGAME_H_

#include "BilliardZ.h"
#include <qlist.h>

class Player;
class PoolTable;
class Physics;
class Rules;
class Sprite;

class PoolGame
{
	public:
		PoolGame(SDL_Surface *screen);
		~PoolGame();

		void start();
		void end();

		void setRules(Rules *rules);

		PoolRoom *getRoom() const;
		PoolTable *getTable() const;
		Physics *getPhysics() const;
		Rules *getRules() const;

		void addPlayer(Player *player);
		void setWinner(Player *player);

		Player *getActivePlayer() const;
		Player *getInactivePlayer() const;
		Player *getPlayer(int num) const;
		Player *getWinner() const;

		int getPlayerCount() const;
		bool isSinglePlayer() const;

		void switchPlayers();

		bool isPlaying() const;

	private:
		void eventLoop();

	private:
		PoolRoom *room;
		Physics *physics;
		int curPlayer;
		int numPlayers;

		Player *players[2];
		Player *winner;

		bool playing;
		Rules *rules;

		QList<Sprite> mouseListeners;
};

#endif /* _POOLGAME_H_ */
