#ifndef _POOLROOM_H_
#define _POOLROOM_H_

#include "BilliardZ.h"

class CueStick;
class PlayerDisplay;
class PoolGame;
class PoolTable;
class PowerMeter;
class Sprite;

class PoolRoom : public Sprite
{
	public:
		PoolRoom(SDL_Surface *screen, PoolGame *game);
		~PoolRoom();

		const char *getName() const;

		void render(bool update = true);
		void render(SDL_Rect rect, bool update = true)
		{ Sprite::render(rect, update); }

		PoolTable *getTable() const;
		CueStick *getCueStick() const;
		PlayerDisplay *getPlayerDisplay() const;
		PowerMeter *getPowerMeter() const;

		void prerender();

	private:
		PoolGame *game;
		PoolTable *table;
		CueStick *cueStick;
		PlayerDisplay *playerDisp;
		PowerMeter *meter;
};

#endif /* _POOLROOM_H_ */
