#ifndef _RULES_H_
#define _RULES_H_

#include "BilliardZ.h"

typedef enum
{
	VALID_BALL,
	INVALID_BALL,
	SCRATCHED,
	PLAYER_WON,
	PLAYER_LOST

} BallResult;

class Rules
{
	public:
		Rules(PoolGame *_game) : game(_game) {}
		virtual ~Rules() {}

		PoolGame *getGame() const { return game; }

		virtual void rackBalls() = 0;
		virtual BallResult ballInHole(Ball *ball, Hole *hole) = 0;
		virtual BallResult ballHit(Ball *ball) = 0;

	private:
		PoolGame *game;
};

#endif /* _RULES_H_ */
