#include "Side.h"
#include <math.h>

Side::Side(SDL_Surface *screen, Uint16 imgNum)
	: Sprite(screen, imgNum, true), dirX(0), dirY(0), c(0)
{
}

Side::~Side()
{
}

const char *
Side::getName() const
{
	return "Side";
}

void
Side::setInfo(Fixed dirX, Fixed dirY, Fixed c)
{
	this->dirX = dirX;
	this->dirY = dirY;
	this->c    = c;
}

Fixed
Side::getDirX() const
{
	return dirX;
}

Fixed
Side::getDirY() const
{
	return dirY;
}

Fixed
Side::collisionPrediction(Ball *ball, Fixed dT)
{
	Fixed centerX, centerY;
	Fixed centerX2, centerY2;
	Fixed velX, velY;
	Fixed radius;
	Fixed time;
	Fixed i, j, distance;

	centerX = ball->getCenterX();
	centerY = ball->getCenterY();

	velX = ball->getVectorX();
	velY = ball->getVectorY();

	radius = ball->getRadius();

	i = (dirX * centerX) + (dirY * centerY) + c;

	if (i < 0)
		i = i.neg();

	distance = i / dirX.hypot(dirY);

	j = (velY * dirY) + (dirX * velX);

	if (j == 0)
		return -1;
	else if (j < 0)
		j = j.neg();

	i = (distance - radius) * dirX.hypot(dirY);
	time = i / j;

	if (time < 0)
		return -1;

	centerX2 = velX.neg() + centerX;
	centerY2 = velY.neg() + centerY;

	i = (dirX * centerX2) + (dirY * centerY2) + c;

	if (i < 0)
		i = i.neg();

	j = i / dirX.hypot(dirY);

	if (j <= distance)
		return -1;

	return time;
}

