#ifndef _VEC2D_H_
#define _VEC2D_H_

#include "Fixed.h"

class Vec2D
{
	public:
		Vec2D();
		Vec2D(const Vec2D &vec);
		Vec2D(Fixed dx, Fixed dy);
		~Vec2D();

		Vec2D addVec(const Vec2D &vec) const;
		Vec2D subVec(const Vec2D &vec) const;
		Vec2D mulVec(const Vec2D &vec) const;
		Vec2D scaleVec(Fixed scale) const;
		Vec2D unitVec() const;
		Fixed abs() const;
		Fixed absSquare() const;
		Fixed dotProd(const Vec2D &vec) const;

		Vec2D proj(const Vec2D &vec) const;

		Vec2D setVec(Fixed dx, Fixed dy);
		Vec2D setVec(const Vec2D &vec);

		Fixed getDx() const;
		Fixed getDy() const;

	private:
		Fixed dx, dy;
};

#endif /* _VEC2D_H_ */
